unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  GmXml, StdCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    TreeView1: TTreeView;
    Button1: TButton;
    Memo1: TMemo;
    Button2: TButton;
    GmXML1: TGmXML;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Label3Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    procedure PopulateTreeView;
    procedure XmlNodeToTreeNode(AXmlNode: TGmXmlNode; ATreeNode: TTreeNode);
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation


uses ShellAPI;
{$R *.DFM}

procedure TForm1.PopulateTreeView;
var
  ATreeRoot: TTreeNode;
  ICount: integer;
begin
  TreeView1.Items.Clear;
  if GmXML1.Nodes.Root = nil then Exit;
  
  // generate the TTreeView content...
  ATreeRoot := TreeView1.Items.Add(nil, GmXML1.Nodes.Root.Name);

  // add each child of the root node to the treeview...
  for ICount := 0 to GmXML1.Nodes.Root.Children.Count-1 do
    XmlNodeToTreeNode(GmXml1.Nodes.Root.Children[ICount], ATreeRoot);

  // expand the first level of the tree...
  TreeView1.Items[0].Expand(False);
end;

procedure TForm1.XmlNodeToTreeNode(AXmlNode: TGmXmlNode; ATreeNode: TTreeNode);
var
  AParentNode: TTreeNode;
  ICount: integer;
begin
  AParentNode := TreeView1.Items.AddChild(ATreeNode, AXmlNode.Name);
  // recursively call this procedure for any children nodes...
  for ICount := 0 to AXmlNode.Children.Count-1 do
    XmlNodeToTreeNode(AXmlNode.Children[ICount], AParentNode);

  // add the data to the tree if the node is a leaf node...
  if AXmlNode.IsLeafNode then
     TreeView1.Items.AddChild(AParentNode, AXmlNode.AsString);
end;

procedure TForm1.Button1Click(Sender: TObject);

  procedure AddBook(Xml: TGmXml; Title, FirstName, LastName: string; Price: Extended);
  begin
    with Xml.Nodes do
    begin
      // add book details...
      AddOpenTag('book');
      AddOpenTag('title').AsString := Title;
      AddCloseTag;
      AddOpenTag('author');
      AddOpenTag('first_name').AsString := FirstName;
      AddCloseTag;
      AddOpenTag('last_name').AsString := LastName;
      AddCloseTag;
      AddOpenTag('price').AsFloat := Price;
      AddCloseTag;
      AddCloseTag;
      AddCloseTag;
    end;
  end;

begin
  GmXML1.Nodes.Clear;

  // build the XML data...
  GmXml1.Nodes.AddOpenTag('bookstore');
  AddBook(GmXml1, 'The Autobiography of Benjamin Franklin', 'Benjamin', 'Franklin', 8.99);
  AddBook(GmXml1, 'The Confidence Man', 'Herman', 'Melville', 11.99);
  GmXml1.Nodes.AddCloseTag;

  // populate the memo with the XML data...
  Memo1.Lines.Text :=  GmXML1.Text;

  // populate the TreeView...
  PopulateTreeView;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  GmXML1.Nodes.Clear;
  Memo1.Lines.Text :=  GmXML1.Text;
  PopulateTreeView;
end;

procedure TForm1.Label3Click(Sender: TObject);
begin
  ShellExecute(0, 'open', PChar( 'http://www.murtsoft.co.uk/gmxml/' ), '', '', SW_SHOW);
end;

end.
