unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  GmXml, StdCtrls;

type
  TPerson = class
  private
    FId: string;
    FName: string;
    FEmail: string;
  public
    procedure SaveToXml(AXmlNode: TGmXmlNode);
    procedure LoadFromXml(AXmlNode: TGmXmlNode);
    property ID: string read FId write FId;
    property Name: string read FName write FName;
    property Email: string read FEmail write FEmail;
  end;

  TForm1 = class(TForm)
    GmXML1: TGmXML;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Memo1: TMemo;
    Label4: TLabel;
    Button1: TButton;
    GroupBox2: TGroupBox;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    Memo2: TMemo;
    procedure Edit1Change(Sender: TObject);
    procedure Edit2Change(Sender: TObject);
    procedure Edit3Change(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private

  public
    Person1: TPerson;
    Person2: TPerson;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TPerson.SaveToXml(AXmlNode: TGmXmlNode);

begin
  with AXmlNode.Children do
  begin
    // create a "person" element...
    AddOpenTag('person');
    // add id value...
    AddOpenTag('id').AsString := FId;
    AddCloseTag;
    // add the name...
    AddOpenTag('name').AsString := FName;
    AddCloseTag;
    // add the email...
    AddOpenTag('email').AsString := FEmail;
    AddCloseTag;
    // close the "person" element...
    AddCloseTag;
  end;
end;

procedure TPerson.LoadFromXml(AXmlNode: TGmXmlNode);
begin
  with AXmlNode.Children do
  begin
    FId   := NodeByName['id'].AsString;
    FName := NodeByName['name'].AsString;
    FEMail:= NodeByName['email'].AsString;
  end;
end;


procedure TForm1.Edit1Change(Sender: TObject);
begin
  Person1.ID := Edit1.Text;
end;

procedure TForm1.Edit2Change(Sender: TObject);
begin
  Person1.Name := Edit2.Text;
end;

procedure TForm1.Edit3Change(Sender: TObject);
begin
  Person1.Email := Edit3.Text;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  ARoot: TGmXmlNode;
begin
  GmXML1.Nodes.Clear;

  ARoot := GmXML1.Nodes.AddOpenTag('company_staff');
  Person1.SaveToXml(ARoot);
  
  Memo1.Lines.Text := GmXML1.Text;

  // we know what the only XML record is, so we can request it by
  // it's name...
  Person2.LoadFromXml(ARoot.Children.NodeByName['person']);

  Edit4.Text := Person2.ID;
  Edit5.Text := Person2.Name;
  Edit6.Text := Person2.Email;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Person1 := TPerson.Create;
  Person2 := TPerson.Create;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  Person1.Free;
  Person2.Free;
end;

end.
